create table ml (
  ml_id int primary key,
  name varchar(64) not null,
  sender varchar(255),
  overview text,
  not_member boolean,
  subject_mlname boolean,
  counter_width int,
  remote_command boolean,
  remote_admin boolean,
  spool boolean,
  web_interface boolean,
  need_confirm_command varchar(255),
  allowed_command varchar(255),
  anonymous_command varchar(255),
  admin_command varchar(255),
  logging boolean,
  replyto_type varchar(255)
);

create table counter (
  counter_id int primary key,
  ml_id int,
  counter int
);

create table address (
  address_id int primary key,
  address varchar(255), 
  password varchar(255),
  unique(address)
);

create table admin (
  admin_id int primary key,
  ml_id int,
  address_id int,
  unique(ml_id, address_id)
);

create table member (
  member_id int primary key,
  ml_id int,
  address_id varchar(255)
);

create table tree (
  tree_id int primary key,
  parent_id int,
  child_id int,
  unique (parent_id, child_id)
);

create table spool (
  spool_id int primary key,
  ml_id int,
  seq int,
  subject varchar(255),
  body text,
  unique (ml_id, seq)
);

create table work (
  work_id int primary key,
  ml_id int,
  lock_id int, 
  data text,
  timestamp timestamp,
  unique (ml_id, lock_id)
);

create table locks (
  lock_id int primary key,
  ident char(255),
  timestamp timestamp
);
